#include "handler.h"
#include <stdio.h>
#include <stdlib.h>

cui_handler_list
cui_handler_list_new(cui_handler hdr, int evt, void *prm, cui_handler_list next)
{
	cui_handler_list list;
	
	if((list = malloc(sizeof(struct cui_handler_list))) == NULL) ERR("No Mem");
	list->hdr = hdr;
	list->evt = evt;
	list->prm = prm;
	list->next = next;
	return list;
}

void
cui_handler_list_free(cui_handler_list list)
{
	if(list == NULL) return;
	cui_handler_list_free(list->next);
	free(list);
}

void
cui_bind(cui obj, int evt, cui_handler hdr, void *prm)
{
	obj->handler_list = cui_handler_list_new(hdr, evt, prm, obj->handler_list);
}

void
cui_unbind(cui obj, int evt, cui_handler hdr)
{
	cui_handler_list *p = &obj->handler_list, list;

	while(*p){
		list = *p;
		if(list->evt & evt && list->hdr == hdr){
			list->evt &= ~evt;
			if(list->evt == 0){
				*p = list->next;
				free(list);
				continue;
			}
		}
		p = &list->next;
	}
}

int
cui_handler_call(cui obj, cui_handler_list list, int evt, int val)
{
	if(list == NULL) return FALSE;
	return (evt & list->evt) && (*list->hdr)(obj, evt, val, list->prm) ? TRUE : 
		cui_handler_call(obj, list->next, evt, val);
}

/* EOF */
