#include "panel.h"
#include "fill.h"

cui
cui_panel_new(cui parent, int x, int y, int w, int h)
{
	cui obj = cui_alloc(sizeof(struct cui_panel));
	cui_panel_init(obj, parent, x, y, w, h);
	return obj;
}

void
cui_panel_init(cui obj, cui parent, int x, int y, int w, int h)
{
	cui_panel p = (cui_panel)obj;
	cui_base_init(obj, parent, x, y, w, h);
	p->fill[0] = cui_fill_new(obj, 0, 0, 0, 0, "-", CUI_ATTR_NORMAL);
	p->fill[1] = cui_fill_new(obj, 0, 0, 0, 0, "-", CUI_ATTR_NORMAL);
	p->fill[2] = cui_fill_new(obj, 0, 0, 0, 0, "|", CUI_ATTR_NORMAL);
	p->fill[3] = cui_fill_new(obj, 0, 0, 0, 0, "|", CUI_ATTR_NORMAL);
	p->fill[4] = cui_fill_new(obj, 0, 0, 0, 0, "+", CUI_ATTR_NORMAL);
	p->fill[5] = cui_fill_new(obj, 0, 0, 0, 0, "+", CUI_ATTR_NORMAL);
	p->fill[6] = cui_fill_new(obj, 0, 0, 0, 0, "+", CUI_ATTR_NORMAL);
	p->fill[7] = cui_fill_new(obj, 0, 0, 0, 0, "+", CUI_ATTR_NORMAL);
	cui_panel_adj(obj);
}

void
cui_panel_adj(cui obj)
{
	cui_panel p = (cui_panel)obj;
	int visi = cui_is_visible(obj);
	if(visi) obj->flags |= CUI_FLG_HIDE;
	cui_xywh_set(p->fill[0], 1, 0, obj->w-2, 1);
	cui_xywh_set(p->fill[1], 1, obj->h-1, obj->w-2, 1);
	cui_xywh_set(p->fill[2], 0, 1, 1, obj->h-2);
	cui_xywh_set(p->fill[3], obj->w-1, 1, 1, obj->h-2);
	cui_xywh_set(p->fill[4], 0, 0, 1, 1);
	cui_xywh_set(p->fill[5], obj->w-1, 0, 1, 1);
	cui_xywh_set(p->fill[6], obj->w-1, obj->h-1, 1, 1);
	cui_xywh_set(p->fill[7], 0, obj->h-1, 1, 1);
	if(visi) obj->flags &= ~CUI_FLG_HIDE;
}

/* EOF */
